From 5bde59dd2de886b7bfc5989acb7a2227bd21bf4a Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Feb 18 2020 09:29:40 +0000
Subject: [PATCH 27/2232] Add buck targets


---

diff --git a/.buckconfig b/.buckconfig
new file mode 100644
index 0000000..33c15ec
--- /dev/null
+++ b/.buckconfig
@@ -0,0 +1,12 @@
+[project]
+  # We use some symlinks in the source tree, but they get eliminated by `cargo
+  # publish` and `cargo vendor` so this allow_symlinks setting should not be
+  # required downstream.
+  allow_symlinks = allow
+
+[cxx]
+  cxxflags = -std=c++11
+
+[rust]
+  default_edition = 2018
+  rustc_flags = -Crelocation-model=dynamic-no-pic --cap-lints=allow
diff --git a/.gitignore b/.gitignore
index a874449..b403b1d 100644
--- a/.gitignore
+++ b/.gitignore
@@ -1,3 +1,5 @@
+/.buckd
+/buck-out
 /Cargo.lock
 /expand.cc
 /expand.rs
diff --git a/BUCK b/BUCK
new file mode 100644
index 0000000..2d12753
--- /dev/null
+++ b/BUCK
@@ -0,0 +1,60 @@
+rust_library(
+    name = "cxx",
+    srcs = glob(["src/**"]),
+    visibility = ["PUBLIC"],
+    deps = [
+        ":core",
+        ":macro",
+        "//third-party:anyhow",
+        "//third-party:cc",
+        "//third-party:codespan",
+        "//third-party:codespan-reporting",
+        "//third-party:link-cplusplus",
+        "//third-party:proc-macro2",
+        "//third-party:quote",
+        "//third-party:syn",
+        "//third-party:thiserror",
+    ],
+)
+
+rust_binary(
+    name = "codegen",
+    srcs = glob(["cmd/src/**"]),
+    visibility = ["PUBLIC"],
+    env = {
+        "CARGO_PKG_AUTHORS": "David Tolnay <dtolnay@gmail.com>",
+    },
+    deps = [
+        "//third-party:anyhow",
+        "//third-party:codespan",
+        "//third-party:codespan-reporting",
+        "//third-party:proc-macro2",
+        "//third-party:quote",
+        "//third-party:structopt",
+        "//third-party:syn",
+        "//third-party:thiserror",
+    ],
+)
+
+cxx_library(
+    name = "core",
+    srcs = ["src/cxxbridge.cc"],
+    visibility = ["PUBLIC"],
+    header_namespace = "cxxbridge",
+    exported_headers = {
+        "cxxbridge.h": "include/cxxbridge.h",
+    },
+    exported_linker_flags = ["-lstdc++"],
+)
+
+rust_library(
+    name = "macro",
+    srcs = glob(["macro/src/**"]),
+    proc_macro = True,
+    crate = "cxxbridge_macro",
+    deps = [
+        "//third-party:proc-macro2",
+        "//third-party:quote",
+        "//third-party:syn",
+    ],
+)
diff --git a/demo-cxx/BUCK b/demo-cxx/BUCK
new file mode 100644
index 0000000..595a18b
--- /dev/null
+++ b/demo-cxx/BUCK
@@ -0,0 +1,16 @@
+cxx_library(
+    name = "demo-cxx",
+    srcs = ["demo.cc"],
+    visibility = ["PUBLIC"],
+    deps = [
+        ":include",
+        "//demo-rs:include",
+    ],
+)
+
+cxx_library(
+    name = "include",
+    exported_headers = ["demo.h"],
+    visibility = ["PUBLIC"],
+    deps = ["//:core"],
+)
diff --git a/demo-rs/BUCK b/demo-rs/BUCK
new file mode 100644
index 0000000..a0f6fb0
--- /dev/null
+++ b/demo-rs/BUCK
@@ -0,0 +1,42 @@
+rust_binary(
+    name = "demo-rs",
+    srcs = glob(["src/**"]),
+    deps = [
+        ":gen",
+        "//:cxx",
+        "//demo-cxx:demo-cxx",
+    ],
+)
+
+cxx_library(
+    name = "gen",
+    srcs = [":gen-source"],
+    deps = [
+        ":include",
+        "//demo-cxx:include",
+    ],
+)
+
+genrule(
+    name = "gen-header",
+    srcs = ["src/main.rs"],
+    cmd = "$(exe //:codegen) --header ${SRCS} > ${OUT}",
+    type = "cxxbridge",
+    out = "gen-demo.h",
+)
+
+genrule(
+    name = "gen-source",
+    srcs = ["src/main.rs"],
+    cmd = "$(exe //:codegen) ${SRCS} > ${OUT}",
+    type = "cxxbridge",
+    out = "gen-demo.cc",
+)
+
+cxx_library(
+    name = "include",
+    exported_headers = {
+        "src/main.rs": ":gen-header",
+    },
+    visibility = ["PUBLIC"],
+)
diff --git a/third-party/.gitignore b/third-party/.gitignore
new file mode 100644
index 0000000..61ead86
--- /dev/null
+++ b/third-party/.gitignore
@@ -0,0 +1 @@
+/vendor
